/*
 * simpleHibernateAppAgent.java
 *
 */

package simpleHibernateApp.agents;

import java.lang.management.ManagementFactory;
import javax.annotation.Resource;
import javax.management.MBeanServer;
import javax.management.ObjectName;
import javax.persistence.EntityManagerFactory;
import javax.persistence.EntityManager;
import javax.persistence.Persistence;
import javax.persistence.PersistenceUnit;
import net.sf.ehcache.CacheManager;
import net.sf.ehcache.management.ManagementService;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.jmx.StatisticsService;

/**
 * JMX agent class.
 * You may use the New JMX MBean wizard to create a Managed Bean.
 * @author maxpoon@dev.java.net
 */
public class simpleHibernateAppAgent {
    
    @PersistenceUnit(unitName = "SimpleHibernateAppPU")
    private EntityManagerFactory emf;

    private EntityManager em  = null;
    private Session session   = null;
    private SessionFactory sf = null;
    
    public simpleHibernateAppAgent( ) { }
    
    /**
     * Instantiate and register your MBeans.
     */
    public void init() throws Exception {
        
        try {
            if (emf == null)
                System.out.println("simpleHibernateAgent: emf=null");
            em = emf.createEntityManager();
            if (em == null)
                System.out.println("simpleHibernateAgent: em=null");
            session = (Session) em.getDelegate();
            if (session == null)
                System.out.println("simpleHibernateAgent: session=null");
            sf = session.getSessionFactory();
            if (sf == null)
                System.out.println("simpleHibernateAgent: sessionFactory=null");
        } catch (Exception ex) {
            System.out.println(ex);
        } finally {
            em.close();
        }

    }
    
    /**
     * Returns an agent singleton.
     */
    public synchronized static simpleHibernateAppAgent getDefault() throws Exception {
        if(singleton == null) {
            singleton = new simpleHibernateAppAgent();
            singleton.init();
        }
        return singleton;
    }
    
    public MBeanServer getMBeanServer() {
        return mbs;
    }
    
    // Platform MBeanServer used to register your MBeans
    private final MBeanServer mbs = ManagementFactory.getPlatformMBeanServer();
    
    // Singleton instance
    private static simpleHibernateAppAgent singleton;
}